; Firebird RC2 installation script(FbSetup.iss)

[Setup]
AppID=Firebird
AppName=Firebird
AdminPrivilegesRequired=true
AllowNoIcons=true
AlwaysCreateUninstallIcon=true
AlwaysShowComponentsList=true
AlwaysShowDirOnReadyPage=true
AlwaysShowGroupOnReadyPage=true
AppVerName=Firebird RC2
AppPublisher=Firebird Team
AppVersion=1.0
AppPublisherURL=http://www.FirebirdSQL.org
AppSupportURL=http://www.FirebirdSQL.org
AppUpdatesURL=http://www.FirebirdSQL.org
AppCopyright=Portions created by Inprise Corporation are Copyright (C) 2000, Inprise Corporation. Portions created by others are Copyright (C) 2000-2002, Firebird Project.

BackColor=clWhite

Compression=bzip
CreateAppDir=true

DefaultDirName={pf}\Firebird
DefaultGroupName=Firebird
DirExistsWarning=auto
DisableDirPage=false
DisableStartupPrompt=false
DisableProgramGroupPage=false

FlatComponentsList=true

LicenseFile=..\license.txt

MessagesFile=compiler:Default.isl
MinVersion=4.0.950,4.0.1381

OutputDir=..\
OutputBaseFilename=FbSetup

ShowComponentSizes=true
SourceDir=.\build

UninstallDisplayIcon={app}\bin\ibserver.exe
UninstallLogMode=append
UninstallFilesDir={app}
Uninstallable=true
UsePreviousAppDir=true
UsePreviousGroup=true
UsePreviousSetupType=true

WizardStyle=modern
WindowShowCaption=true
WindowStartMaximized=false
WindowVisible=false
WindowResizable=true
WizardImageFile=compiler:WizModernImage.bmp
WizardImageBackColor=$808000
WizardSmallImageFile=compiler:WizModernSmallImage.bmp
WizardDebug=false

[Types]
Name: full; Description: Full installation
Name: compact; Description: Compact installation
Name: custom; Description: Customized installation; Flags: iscustom

[Components]
Name: Main; Description: Firebird Database Server; Types: full compact custom; Flags: fixed
Name: Docs; Description: Help, fixed bugs, features and release notes; Types: full compact custom; Flags: fixed
Name: Examples; Description: Examples; Types: full custom
Name: Other; Description: Other files not necessary to run Firebird; Types: full custom

[Files]
Source: *.*; DestDir: {app}; Components: Main
Source: ISC4.GDB; DestDir: {app}; CopyMode: onlyifdoesntexist; DestName: ISC4.GDB; Components: Main
Source: ..\license.txt; DestDir: {app}; Components: Main
Source: ..\msvcrt.dll; DestDir: {sys}; Components: Main; CopyMode: onlyifdoesntexist; Flags: sharedfile uninsneveruninstall
Source: bin\*.*; DestDir: {app}\bin; Components: Main
Source: ..\FbSvc\FbSvc.exe; DestDir: {app}\bin; Components: Main
Source: doc\*.*; DestDir: {app}\doc; Components: Docs
Source: examples\*.*; DestDir: {app}\examples; Components: Examples
Source: help\*.*; DestDir: {app}\help; Components: Other
Source: include\*.*; DestDir: {app}\include; Components: Other
Source: intl\*.*; DestDir: {app}\intl; Components: Main
Source: lib\*.*; DestDir: {app}\lib; Components: Other
Source: UDF\*.*; DestDir: {app}\UDF; Components: Main
Source: bin\gds32.dll; DestDir: {sys}\; CopyMode: alwaysskipifsameorolder; Flags: comparetimestampalso confirmoverwrite overwritereadonly sharedfile restartreplace; Components: Main

[Icons]
Name: {group}\Release Notes; Filename: {app}\doc\Firebird_v1_ReleaseNotes.pdf; WorkingDir: {app}\doc
Name: {group}\Readme; Filename: {app}\Readme.txt; WorkingDir: {app}

[Registry]
Root: HKLM; Subkey: Software\Borland\InterBase\CurrentVersion; ValueType: string; ValueName: GuardianOptions; ValueData: 1
Root: HKLM; Subkey: Software\Borland\InterBase\CurrentVersion; ValueType: string; ValueName: ServerDirectory; ValueData: {app}\bin
Root: HKLM; Subkey: SYSTEM\CurrentControlSet\Services\InterBaseGuardian; ValueType: string; ValueName: Description; ValueData: Assures that the Firebird Database Server is running.
Root: HKLM; Subkey: SYSTEM\CurrentControlSet\Services\InterBaseServer; ValueType: string; ValueName: Description; ValueData: Firebird Database Server

[Run]
Filename: {app}\bin\instreg.exe; Parameters: "install ""{app}"""; WorkingDir: {app}\bin; Flags: runminimized
Filename: {app}\bin\instsvc.exe; Parameters: "install ""{app}"" -auto"; WorkingDir: {app}\bin; Flags: runminimized
FileName: {app}\bin\FbSvc.exe; Parameters: /install_guardian; WorkingDir: {app}\bin; Flags: runminimized

[UninstallRun]
FileName: {app}\bin\FbSvc.exe; Parameters: /deinstall_guardian; WorkingDir: {app}\bin; Flags: runminimized
FileName: {app}\bin\FbSvc.exe; Parameters: /stop_server; WorkingDir: {app}\bin; Flags: runminimized
Filename: {app}\bin\instsvc.exe; Parameters: remove; WorkingDir: {app}\bin; Flags: runminimized
Filename: {app}\bin\instreg.exe; Parameters: remove; WorkingDir: {app}\bin; Flags: runminimized

[UninstallDelete]
Name: {app}; Type: filesandordirs
