program FbSvc;

uses
	Forms,
	Registry,
	Windows,
	Messages,
	Dialogs,
	WinSvc,
	SysUtils;

{$R *.RES}

function GetPath: String;
var
	regFirebird: TRegistry;
begin
	Result := '';
	regFirebird := TRegistry.Create;
	try
		regFirebird.RootKey := HKEY_LOCAL_MACHINE;
		if (regFirebird.OpenKeyReadOnly('Software\Borland\InterBase\CurrentVersion') = True) then
			Result := Trim(regFirebird.ReadString('RootDirectory'));
	finally
		regFirebird.CloseKey;
		regFirebird.Free;
	end;
end;

function IsNT: Boolean;
var
	OSVersion: TOSVersionInfo;
begin
	Result := False;
	OSVersion.dwOSVersionInfoSize := SizeOf(OSVersion);
	if (GetVersionEx(OSVersion)) then
	begin
		case OSVersion.dwPlatformID of
			VER_PLATFORM_WIN32_NT:
				Result := True;
			else
				Result := False;
		end;
	end;
end;

function StopServer: Boolean;
var
	lHWND: HWND;
	sFirebirdPath, sExecName: String;
	lArray: array[0..255] of Char;
begin
	Result := False;
	if (IsNT = True) then
	begin
		sFirebirdPath := GetPath;
		if (sFirebirdPath <> '') then
		begin
			sExecName := Format('%s%s', [sFirebirdPath, 'bin\instsvc.exe stop']);
			if (WinExec(StrPCopy(lArray, sExecName), 2) > 31) then
				Result := True;
		end;
	end
	else
	begin
		lHWND := FindWindow('IB_Server', 'InterBase Server');
		if (PostMessage(lHWND, WM_CLOSE, 0, 0) <> Null) then
			Result := True;
		Application.ProcessMessages;
	end;
end;

function InstallAndStartGuardian: Boolean;
var
	hanManager, hanGuardian: SC_Handle;
	ss: TServiceStatus;
	dwChkP: DWord;
	sTemp: PCHar;
	bResultInstall, bResultStart: Boolean;
	lArray: array[0..255] of Char;
	sFirebirdPath, sExecName: String;
begin
	Result := False;
	if (IsNT = True) then
	begin
		hanManager := OpenSCManager(nil, nil, SC_MANAGER_ALL_ACCESS);
		try
			if (hanManager <> 0) then
			begin
				hanGuardian := CreateService(hanManager, 'InterBaseGuardian', 'InterBase Guardian', SERVICE_ALL_ACCESS, SERVICE_WIN32_OWN_PROCESS or SERVICE_INTERACTIVE_PROCESS,
					SERVICE_AUTO_START, SERVICE_ERROR_NORMAL, PChar(GetPath + 'bin\ibguard.exe -s'), nil, nil, nil, nil, nil);
				try
					hanGuardian := OpenService(hanManager, 'InterBaseGuardian', SERVICE_START or SERVICE_QUERY_STATUS);
					sTemp := nil;
					if (hanGuardian <> 0) then
					begin
						if (StartService(hanGuardian, 0, sTemp) = True) then
							if (QueryServiceStatus(hanGuardian, ss) = True) then
								while (SERVICE_RUNNING <> ss.dwCurrentState) do
								begin
									dwChkP := ss.dwCheckPoint;
									Sleep(ss.dwWaitHint);
									if not (QueryServiceStatus(hanGuardian, ss) = True) then
										Break;
									if (ss.dwCheckPoint < dwChkP) then
										Break;
								end;
						Result := (SERVICE_RUNNING = ss.dwCurrentState);
					end;
				finally
					CloseServiceHandle(hanGuardian);
				end;
			end;
		finally
			CloseServiceHandle(hanManager);
		end;
	end
	else
	begin
		bResultInstall := False;
		bResultStart := False;
		sFirebirdPath := GetPath;
		with TRegistry.Create do
			try
				RootKey := HKEY_LOCAL_MACHINE;
				if (OpenKey('Software\Microsoft\Windows\CurrentVersion\Run', False) = True) then
				begin
					WriteString('Firebird Guardian', sFirebirdPath + 'bin\ibguard.exe -a');
					bResultInstall := True;
				end;
			finally
				CloseKey;
				Free;
			end;
		if (sFirebirdPath <> '') then
		begin
			sExecName := Format('%s%s', [sFirebirdPath, 'bin\ibguard.exe']);
			if (WinExec(StrPCopy(lArray, sExecName), 2) > 31) then
				bResultStart := True;
		end;
		if ((bResultInstall = True) and (bResultStart = True)) then
			Result := True;
	end;
end;

function StopAndDeinstallGuardian: Boolean;
var
	hanManager, hanGuardian: SC_Handle;
	lHWND: HWND;
	ss: TServiceStatus;
	dwChkP:DWord;
	bResultStop, bResultDeinstall: Boolean;
begin
	Result := False;
	if (IsNT = True) then
	begin
		hanManager := OpenSCManager(nil, nil, SC_MANAGER_ALL_ACCESS);
		try
			if (hanManager <> 0) then
			begin
				hanGuardian := OpenService(hanManager, 'InterBaseGuardian', SC_MANAGER_ALL_ACCESS);
				try
					if (hanGuardian <> 0) then
					begin
						if (ControlService(hanGuardian, SERVICE_CONTROL_STOP, ss) = True) then
							if (QueryServiceStatus(hanGuardian, ss) = True) then
								while (SERVICE_STOPPED <> ss.dwCurrentState) do
								begin
									dwChkP := ss.dwCheckPoint;
									Sleep(ss.dwWaitHint);
									if not (QueryServiceStatus(hanGuardian, ss) = True) then
										Break;
									if (ss.dwCheckPoint < dwChkP) then
										Break;
								end;
							bResultStop := (SERVICE_STOPPED = ss.dwCurrentState);
							bResultDeinstall := DeleteService(hanGuardian);
							if ((bResultStop = True) and (bResultDeinstall = True)) then
								Result := True;
					end;
				finally
					CloseServiceHandle(hanGuardian);
				end;
			end;
		finally
			CloseServiceHandle(hanManager);
		end;
	end
	else
	begin
		bResultStop := False;
		bResultDeinstall := False;
		lHWND := FindWindow('IB_Guard', 'InterBase Guardian');
		if (PostMessage(lHWND, WM_CLOSE, 0, 0) <> Null) then
			bResultStop := True;
		Application.ProcessMessages;
		with TRegistry.Create do
			try
				RootKey := HKEY_LOCAL_MACHINE;
				if (OpenKey('Software\Microsoft\Windows\CurrentVersion\Run', False) = True) then
					bResultDeinstall := DeleteValue('Firebird Guardian');
			finally
				CloseKey;
				Free;
			end;
		if ((bResultStop = True) and (bResultDeinstall = True)) then
			Result := True;
	end;
end;

var
	I: Byte;
begin
	for I := 1 to ParamCount do
	begin
		if (UpperCase(ParamStr(I)) = '/INSTALL_GUARDIAN') then
			InstallAndStartGuardian;
		if (UpperCase(ParamStr(I)) = '/DEINSTALL_GUARDIAN') then
			StopAndDeinstallGuardian;
		if (UpperCase(ParamStr(I)) = '/STOP_SERVER') then
			StopServer;
	end;
	Application.Initialize;
end.
